// 002 u_c_3d_vertex
// 26 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_3d_vertex;
  interface
    uses Classes, u_c_basic_object
        , u_3d_point
        ;

    type c_3d_vertex= // one "3d_vertex"
                      Class(c_basic_object)
                        m_vertex_id: integer;
                        m_3d_point: t_3d_point;

                        constructor create_3d_vertex(p_name: String; p_3d_point: t_3d_point);
                        function f_display_3d_vertex: String;
                        function f_c_self: c_3d_vertex;

                        procedure translate_3d_vertex(p_3d_delta: t_3d_point);
                        Destructor Destroy; Override;
                     end; // c_3d_vertex

  implementation
    uses Graphics, SysUtils, u_c_display;

    // -- c_3d_vertex

    Constructor c_3d_vertex.create_3d_vertex(p_name: String; p_3d_point: t_3d_point);
      begin
        Inherited create_basic_object(p_name);

        m_3d_point:= f_multiply_3d_point_by_scalar(p_3d_point, 1.0/40);
      end; // create_3d_vertex

    function c_3d_vertex.f_display_3d_vertex: String;
      begin
        Result:= Format('%-10s ', [m_name]);
      end; // f_display_3d_vertex

    function c_3d_vertex.f_c_self: c_3d_vertex;
      begin
        Result:= Self;
      end; // f_c_self

    procedure c_3d_vertex.translate_3d_vertex(p_3d_delta: t_3d_point);
      begin
        m_3d_point:= f_add_3d_point(m_3d_point, p_3d_delta);
      end; // translate_3d_vertex

    Destructor c_3d_vertex.Destroy;
      begin
        InHerited;
      end; // Destroy

    begin // u_c_3d_vertex_list
    end. // u_c_3d_vertex_list
