// 002 u_trigonometry
// 19 mar 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_trigonometry;
  interface
    Const k_pi_div_180= pi / 180.0;
          k_180_div_pi= 180.0 / pi;

    function f_sine(p_angle: Double): Double;
    function f_cosine(p_angle: Double): Double;
    function f_tangent(p_angle: Double): Double;

    function f_arc_cosine(p_cosine: Double): Double;

    Function f_radian(p_angle: Double): Double;
    Function f_degree(p_angle: Double): Double;

    Function f_degree_cosine(p_angle: Double): Double;
    Function f_degree_sine(p_angle: Double): Double;

  implementation
    uses Math // ArcCos
        , u_double;

    function f_sine(p_angle: Double): Double;
      begin
        Result:= sin(p_angle);
      end; // f_sine

    function f_cosine(p_angle: Double): Double;
      begin
        Result:= cos(p_angle);
      end; // f_cosine

    function f_tangent(p_angle: Double): Double;
      var l_cosine: Double;
      begin
        l_cosine:= f_cosine(p_angle);
        if f_double_is_null(l_cosine)
          then Result:= 1/ g_epsilon
          else Result:= f_sine(p_angle)/ l_cosine;
      end; // f_tangent

    function f_arc_cosine(p_cosine: Double): Double;
        // -- exception when too close to 1 (from ArcTan ?)
      begin
        if f_double_is_null(Abs(p_cosine)- 1)
          then begin
              if p_cosine< 0
                then Result:= pi
                else Result:= 0
            end
          else Result:= ArcCos(p_cosine);
      end; // f_arc_cosine

    Function f_radian(p_angle: Double): Double;
      Begin
        Result:= p_angle* k_pi_div_180;
      End; // f_radians

    Function f_degree(p_angle: Double): Double;
      Begin
        Result:= p_angle* k_180_div_pi;
      End; // f_degres

    Function f_degree_cosine(p_angle: Double): Double;
      Begin
        Result:= Cos(f_radian(p_angle));
      End; // f_degree_cosine

    Function f_degree_sine(p_angle: Double): Double;
      Begin
        Result:= Sin(f_radian(p_angle));
      End; // f_degree_sine

    begin // principal
    end. // principal
