// 002 u_delphi_3d_designer
// 28 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_delphi_3d_designer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, Spin, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    Panel3: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel5: TPanel;
    screen_panel_: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    azimuth_edit_: TEdit;
    elevation_edit_: TEdit;
    scale_edit_: TEdit;
    Panel6: TPanel;
    palette_panel_: TPanel;
    cube_speed_button_: TSpeedButton;
    pyramid_speed_button_: TSpeedButton;
    horizontal_speed_button_: TSpeedButton;
    vertical_east_speed_button_: TSpeedButton;
    vertical_front_speed_button_: TSpeedButton;
    Panel9: TPanel;
    fill_: TCheckBox;
    normal_: TCheckBox;
    draw_figure_: TButton;
    display_figure_: TButton;
    Panel11: TPanel;
    create_scaler_: TButton;
    create_perspective_: TButton;
    create_volumes_: TButton;
    create_: TButton;
    create_2_: TButton;
    display_: TCheckBox;
    Panel12: TPanel;
    scene_panel_: TPanel;
    scene_paintbox_: TPaintBox;
    Panel10: TPanel;
    reset_position_: TButton;
    new_volume_edit_: TEdit;
    x_: TRadioButton;
    y_: TRadioButton;
    z_: TRadioButton;
    selected_edit_: TEdit;
    PageControl1: TPageControl;
    mouse_: TTabSheet;
    Panel4: TPanel;
    perspective_paintbox_: TPaintBox;
    Panel13: TPanel;
    draw_controler_: TButton;
    scrollbar: TTabSheet;
    azimuth_trackbar_: TTrackBar;
    elevation_trackbar_: TTrackBar;
    scale_trackbar_: TTrackBar;
    spheric_: TTabSheet;
    spheric_azimuth_trackbar_: TTrackBar;
    spheric_elevation_trackbar_: TTrackBar;
    radius_trackbar_: TTrackBar;
    camera_edit_: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure create_perspective_Click(Sender: TObject);
    procedure draw_controler_Click(Sender: TObject);
    procedure create_scaler_Click(Sender: TObject);
    procedure fill_Click(Sender: TObject);
    procedure ratio_Click(Sender: TObject);
    procedure disp_vol_0_Click(Sender: TObject);
    procedure reset_position_Click(Sender: TObject);
    procedure x_Click(Sender: TObject);
    procedure normal_Click(Sender: TObject);
    procedure cube_speed_button_Click(Sender: TObject);
    procedure pyramid_speed_button_Click(Sender: TObject);
    procedure create_2_Click(Sender: TObject);
    procedure horizontal_speed_button_Click(Sender: TObject);
    procedure vertical_east_speed_button_Click(Sender: TObject);
    procedure vertical_front_speed_button_Click(Sender: TObject);
    procedure draw_figure_Click(Sender: TObject);
    procedure create_volumes_Click(Sender: TObject);
    procedure create_Click(Sender: TObject);
    procedure display_Click(Sender: TObject);
    procedure azimuth_trackbar_Change(Sender: TObject);
    procedure elevation_trackbar_Change(Sender: TObject);
    procedure scale_trackbar_Change(Sender: TObject);
    procedure spheric_elevation_trackbar_Change(Sender: TObject);
    procedure spheric_azimuth_trackbar_Change(Sender: TObject);
    procedure radius_trackbar_Change(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir

        , u_double
        , u_trigonometry

        , u_2d_integer_point
        , u_2d_point
        , u_3d_point

        , u_c_perspective
        , u_c_camera_controler
        , u_c_screen_controler

        , u_c_3d_vertex_list
        , u_c_facet_list
        , u_c_volume_list

        , u_c_scene

        ;

    {$R *.DFM}

    var g_c_volume_list: c_volume_list= Nil;
        g_c_perspective: c_perspective= Nil;

        g_c_camera_controler: c_camera_controler= Nil;
        g_c_screen_controler: c_screen_controler= Nil;

        g_c_scene: c_scene= Nil;

    procedure update_perspective;
      var l_step_x, l_step_y: Integer;
          l_camera_x, l_camera_y, l_camera_z: Integer;
      begin
        with g_c_perspective do
        begin
          with Form1.scene_paintbox_ do
          begin
            l_camera_x:= Round(10* f_sine(g_c_camera_controler.m_azimuth));
            l_camera_y:= Round(10* f_cosine(g_c_camera_controler.m_azimuth));
            l_camera_z:= Round(10* f_tangent(g_c_camera_controler.m_elevation));

            if f_double_is_null(g_c_camera_controler.m_scale_ratio)
              then initialise_camera_position(l_camera_x, l_camera_y, l_camera_z, 10 )
              else initialise_camera_position(l_camera_x, l_camera_y, l_camera_z, 10 / g_c_camera_controler.m_scale_ratio);

            l_step_x:= Width div 2;
            l_step_y:= Height div 2;

            initialize_screen_position(
                Round(l_step_x* (1+ g_c_screen_controler.m_ratio_x)),
                Round(l_step_y* (1+ g_c_screen_controler.m_ratio_y)),
                Round(l_step_x* g_c_screen_controler.m_ratio_width),
                Round(l_step_y* g_c_screen_controler.m_ratio_width));
          end; // with Form1.PaintBox1
        end; // with g_c_camera
      end; // update_perspective

    procedure draw_the_figure(p_pen_color: Integer);
      begin
        g_c_perspective.draw_unit_axes(p_pen_color);
        g_c_volume_list.draw(g_c_perspective, p_pen_color);
      end; // draw_the_figure

    procedure handle_controler_changed(p_before: Boolean);
      begin
        if p_before
          then draw_the_figure(clWhite)
          else begin
              with Form1, g_c_camera_controler do
              begin
                display('az='+ f_display_2d_point(m_2d_azimuth)
                  + ' el='+ f_display_2d_point(m_2d_elevation)
                  + ' el_a '+ f_display_double(f_degree(m_elevation), 1, 2));
                azimuth_edit_.Text:= f_display_double(f_degree(m_azimuth), 4, 2);
                elevation_edit_.Text:= f_display_double(f_degree(m_elevation), 4, 2);
                scale_edit_.Text:= f_display_double(m_scale_ratio, 2, 2);
              end;

              update_perspective;
              with Form1, g_c_camera_controler do
                camera_edit_.Text:= f_display_3d_point(g_c_perspective.m_3d_camera);

              draw_the_figure(clBlack);
            end
      end; // handle_controler_changed

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure handle_scene_change;
      begin
        with g_c_scene do
          if m_c_selected_volume= Nil
            then Form1.selected_edit_.Text:= ''
            else Form1.selected_edit_.Text:= m_c_selected_volume.m_name
      end; // handle_scene_change

    procedure handle_scaler_change;
      begin
        if g_c_perspective<> Nil
          then begin
              Form1.scene_paintbox_.Repaint;
              update_perspective;
              draw_the_figure(clBlack);
            end;
      end; // handle_scaler_change

    procedure TForm1.create_scaler_Click(Sender: TObject);
      begin
        g_c_screen_controler:= c_screen_controler.create_screen_controler('scale',
            screen_panel_, 0.25,
            // 2.0, 2.0, -0.5, -0.5, handle_scaler_change);
            1.0, 1.0, 0.2, 0.2, handle_scaler_change);
      end; // create_scaler_Click

    procedure TForm1.create_perspective_Click(Sender: TObject);
      begin
        if g_c_screen_controler= Nil
          then create_scaler_Click(Nil);

        g_c_camera_controler:= c_camera_controler.create_camera_controler('perspective_controler',
            perspective_paintbox_, 0.5, handle_controler_changed);

        with g_c_camera_controler do
        begin
          m_azimuth:= 45* k_pi_div_180;
          m_elevation:= 30* k_pi_div_180;
        end; // with g_c_camera_controler

        g_c_perspective:= c_perspective.create_perspective('perps', scene_paintbox_.Canvas);
        with g_c_perspective do
        begin
          m_draw_color:= fill_.Checked;
          update_perspective;
          draw_unit_axes(clRed);
          m_draw_normal:= normal_.Checked;
        end; // with g_c_perspective
      end; // create_perspective_Click

    procedure TForm1.create_volumes_Click(Sender: TObject);
      begin
        if g_c_perspective= Nil
          then create_perspective_Click(Nil);

        g_c_volume_list:= c_volume_list.create_volume_list('volume');

        g_c_scene:= c_scene.create_scene('scene', scene_paintbox_,
            g_c_volume_list, g_c_perspective,
            handle_scene_change);

        // -- initialize the direction
        x_Click(Nil);
      end; // create_volumes_Click

    procedure TForm1.create_Click(Sender: TObject);
      begin
        create_scaler_Click(Nil);
        create_perspective_Click(Nil);
        create_volumes_Click(Nil);
      end; // create_Click

    // -- redraw the controler

    procedure TForm1.draw_controler_Click(Sender: TObject);
      begin
        with g_c_camera_controler do
          draw_all(clAqua);
      end; // paint_controler_Click

    // -- coloring surfaces

    procedure TForm1.fill_Click(Sender: TObject);
        // -- add or remove the surface painting
      begin
        if g_c_perspective<> Nil
          then begin
              g_c_perspective.m_draw_color:= fill_.Checked;
              // -- remove the yellow
              scene_paintbox_.Repaint;
              draw_the_figure(clBlack);
            end;
      end; // color_Click

    // -- scaling the screen

    procedure TForm1.ratio_Click(Sender: TObject);
      begin
        if g_c_screen_controler<> Nil
          then begin
              display(g_c_screen_controler.f_display_ratios);
              Caption:= g_c_screen_controler.f_display_ratios;
            end;
      end; // ratio_Click

    procedure TForm1.disp_vol_0_Click(Sender: TObject);
      begin
        g_c_volume_list.f_c_volume(0).display_unique_facet_list;
      end; // vol_0_Click

    procedure TForm1.reset_position_Click(Sender: TObject);
      begin
        if g_c_scene.m_c_selected_volume<> Nil
          then begin
              g_c_volume_list.draw(g_c_perspective, clWhite);
              g_c_scene.m_c_selected_volume.set_position(f_3d_Point(0, 0, 0));
              g_c_volume_list.draw(g_c_perspective, clBlack);
            end;
      end;

    procedure TForm1.x_Click(Sender: TObject);
        // -- clich a direction radio button
      var l_direction: t_direction;
      begin
        if g_c_scene= Nil
          then Exit;

        if x_.Checked
          then l_direction:= e_x_direction
          else
            if y_.Checked
              then l_direction:= e_y_direction
              else
                if z_.Checked
                  then l_direction:= e_z_direction
                  else l_direction:= e_unknown_direction;

        g_c_scene.set_direction(l_direction);
      end; // x_Click

    procedure TForm1.normal_Click(Sender: TObject);
      begin
        if g_c_perspective<> Nil
          then g_c_perspective.m_draw_normal:= normal_.Checked;
      end; // normal_Click

    procedure check_scene;
      begin
        if g_c_scene= Nil
          then begin
              Form1.create_Click(Nil);
              // Form1.scene_Click(Nil);
            end;
      end; // check_scene

    var g_volume_id: Integer= 1;

    procedure TForm1.cube_speed_button_Click(Sender: TObject);
      begin
        check_scene;
        new_volume_edit_.Text:= 'cube_'+ IntToStr(g_volume_id);
        Inc(g_volume_id);
        g_c_volume_list.add_cube(new_volume_edit_.Text);
        draw_the_figure(clBlack);
      end; // cube_speed_button_Click

    procedure TForm1.pyramid_speed_button_Click(Sender: TObject);
      begin
        check_scene;
        new_volume_edit_.Text:= 'pyramid_'+ IntToStr(g_volume_id);
        Inc(g_volume_id);
        g_c_volume_list.add_pyramid(new_volume_edit_.Text);
        draw_the_figure(clBlack);
      end; // pyramid_speed_button_Click

    procedure TForm1.horizontal_speed_button_Click(Sender: TObject);
      begin
        check_scene;
        new_volume_edit_.Text:= 'horiz_'+ IntToStr(g_volume_id);
        Inc(g_volume_id);
        g_c_volume_list.add_horizontal_plane(new_volume_edit_.Text);
        draw_the_figure(clBlack);
      end; // horizontal_speed_button_Click

    procedure TForm1.vertical_east_speed_button_Click(Sender: TObject);
      begin
        check_scene;
        new_volume_edit_.Text:= 'east_'+ IntToStr(g_volume_id);
        Inc(g_volume_id);
        g_c_volume_list.add_vertical_x0z_plane(new_volume_edit_.Text);
        draw_the_figure(clBlack);
      end; // vertical_east_speed_button_Click

    procedure TForm1.vertical_front_speed_button_Click(Sender: TObject);
      begin
        check_scene;
        new_volume_edit_.Text:= 'front_'+ IntToStr(g_volume_id);
        Inc(g_volume_id);
        g_c_volume_list.add_vertical_y0z_plane(new_volume_edit_.Text);
        draw_the_figure(clBlack);
      end; // vertical_front_speed_button_Click

    procedure TForm1.create_2_Click(Sender: TObject);
      var l_x, l_y: Integer;
      begin
        // -- create the volume list
        check_scene;

        // -- create one cube
        cube_speed_button_Click(Nil);

        // -- force the display, with a reasonable camera position
        with perspective_paintbox_ do
        begin
          l_x:= (Width* 7) div 13;
          l_y:= (Height* 5) div 6;
          // display(IntToStr(l_x)+ ' '+ IntToStr(l_y)+ ' '+ IntToStr(Width)+ ' '+ IntToStr(Height));
          OnMouseDown(Nil, mbLeft, [ssLeft], l_x, l_y);
          with g_c_camera_controler do
          begin
            m_is_azimuth:= False;
            m_is_elevation:= True;
            update_controler(l_x, l_y- 20);
          end;
        end;
        // -- move the cube away from the origin
        g_c_volume_list.f_c_volume(0).translate_facet_list(f_3d_point(1, 0, 0));

        // -- create a second volume
        new_volume_edit_.Text:= 'cube2';
        cube_speed_button_Click(Nil);

        draw_the_figure(clBlack);
      end; // create_2_Click

    procedure TForm1.draw_figure_Click(Sender: TObject);
      begin
        draw_the_figure(clBlack);
      end;

    procedure TForm1.display_Click(Sender: TObject);
      begin
        Memo1.Visible:= display_.Checked;
      end;

    procedure TForm1.azimuth_trackbar_Change(Sender: TObject);
      begin
        draw_the_figure(clWhite);
        g_c_camera_controler.m_azimuth:= f_radian(azimuth_trackbar_.Position);
        handle_controler_changed(False);
      end; // azimuth_trackbar_Change

    procedure TForm1.elevation_trackbar_Change(Sender: TObject);
      begin
        draw_the_figure(clWhite);
        g_c_camera_controler.m_elevation:= f_radian(elevation_trackbar_.Position);
        handle_controler_changed(False);
      end; // elevation_trackbar_Change

    procedure TForm1.scale_trackbar_Change(Sender: TObject);
      begin
        draw_the_figure(clWhite);
        with scale_trackbar_ do
          g_c_camera_controler.m_scale_ratio:= 1+ Position/ 50;
        handle_controler_changed(False);
      end; // scale_trackbar_Change

    procedure TForm1.spheric_azimuth_trackbar_Change(Sender: TObject);
      begin
        azimuth_trackbar_.Position:= spheric_azimuth_trackbar_.Position;
        azimuth_trackbar_Change(Nil);
      end; // spheric_azimuth_trackbar_Change

    procedure TForm1.spheric_elevation_trackbar_Change(Sender: TObject);
      var l_radius, l_radius_projection: Double;
      begin
        elevation_trackbar_.Position:= spheric_elevation_trackbar_.Position;

        draw_the_figure(clWhite);
        g_c_camera_controler.m_elevation:= f_radian(spheric_elevation_trackbar_.Position);

        // -- also change the elevation
        // -- this computes the radius projection
        with radius_trackbar_ do
          l_radius:= (1+ Position/ 50);
        l_radius_projection:= l_radius* f_cosine(f_radian(spheric_elevation_trackbar_.Position));
        g_c_camera_controler.m_scale_ratio:= l_radius_projection;

        handle_controler_changed(False);
      end; // spheric_elevation_trackbar_Change

    procedure TForm1.radius_trackbar_Change(Sender: TObject);
      var l_radius, l_radius_projection: Double;
      begin
        draw_the_figure(clWhite);
        with radius_trackbar_ do
          l_radius:= (1+ Position/ 50);

        l_radius_projection:= l_radius* f_cosine(f_radian(spheric_elevation_trackbar_.Position));
        g_c_camera_controler.m_scale_ratio:= l_radius_projection;

        handle_controler_changed(False);
      end;

end.


